<?php
//お問い合わせのショートコード生成
require_once('validate-form-value.php');

function iqfm_inquiry_form_shortcode($atts) {
	global $wpdb;
	$obj = new IQFM_Front;
	//サニタイズ
	if (is_array($_POST)) {
		foreach($_POST as $key => $post) {
			if(strpos($key, 'checkbox') !== false) {
				foreach($post as $key2 => $checkbox) {
					$_POST[$key][$key2] = maybe_serialize( stripslashes_deep(trim($checkbox)));
				}
			} else {
				$_POST[$key] = maybe_serialize( stripslashes_deep(trim($post)));
			}
		}
	}

	// 属性を取り出す
	extract(shortcode_atts(array(
		'form_id' => 1
	), $atts));
	

	//公開期間の確認
	$result = $wpdb->get_results('SELECT publish_flg, publishstart_dt, publishend_dt FROM '.$wpdb->prefix.'iqfm_inquiryform WHERE delete_flg = 0 and form_id='.$form_id, ARRAY_A);

	if ($result[0]['publish_flg'] == 1) {
		$start = strtotime($result[0]['publishstart_dt']);
		$end   = strtotime($result[0]['publishend_dt']);
		$now   = time();
	}

	if ($result[0]['publish_flg'] == 1 && ($start > $now || $end < $now )) {
		return '';
	}
	
	// html生成
	$result = $wpdb->get_results('SELECT form_component_id, field_type, field_name, field_subject, field_html, field_option, field_validation, attention_message FROM '.$wpdb->prefix.'iqfm_inquiryform_component WHERE new_flg = 0 and delete_flg = 0 and form_id='.$form_id.' order by field_sort', ARRAY_A);

	if (array_key_exists('inqirymode', $_POST) && $_POST['inqirymode'] == 'input') {
		$err  = iqfm_execute_validation();

		if ($err === false) {
			$html = $obj->show_confirm($result, $form_id);
		} else {
			$html = $obj->show_input($result, $form_id, $err);
		}
	} elseif (array_key_exists('inquirymode', $_POST) && $_POST['inquirymode'] == 'confirm') {
		$err  = iqfm_execute_validation();

		if ($err === false) {
			$obj->save($result, $form_id);
			$obj->send_admin_mail($result, $form_id);
			$html = $obj->show_finish();
		} else {
			$html = $obj->show_input($result, $form_id, $err);
		}
	} else {
		$html = $obj->show_input($result, $form_id);
	}
	
	return $html;
}

class IQFM_Front {

public function show_input($result, $form_id, $err = false){

	$html = "";
	$html .= '<form id="inquiryform-'.$form_id.'" method="POST" action=""><table id="iqfm-input-'.$form_id.'" class="iqfm-table">';
	$count = 1;
	foreach($result as $element){
		$html .= '<tr><td id="iqfm-input-'.$count.'" class="iqfm-input" style="vertical-align:top;">'.esc_html($element['field_subject']).'<span style="font-size:70%" >&nbsp;&nbsp;'.esc_html($element['attention_message']).'</span><br />'.$this->create_element($element, $count).$this->show_err($err, esc_html($element['field_name'])).'</td></tr>';
		$count++;
		if ($element['field_option'] === 'confirm') {
			$html .= '<tr><td id="iqfm-input-'.$count.'" class="iqfm-input" style="vertical-align:top;">'.esc_html($element['field_subject']).'<span style="font-size:70%" >(確認用)</span><br />'.$this->create_element($element, $count, 'confirm').'</td></tr>';
			$count++;
		}
	}
	$html .= '</table><input type="hidden" name="inqirymode" value="input" /><input type="hidden" name="form_id" value="'.esc_html($form_id).'" /><input type="submit" id="1nquiryformSubmit-'.esc_html($form_id).'" value="確認画面へ" /></form>';
	
	return $html;
}

public function show_confirm($result, $form_id){
	
	$javascript = '<script type="text/javascript">
		function inquirySubmit(mode) {
			o=document.createElement("input");
			o.setAttribute("type", "hidden");
			o.name="inquirymode";
			o.value=mode;
			document.getElementById("inquiryform-'.esc_html($form_id).'").appendChild(o);
			document.getElementById("inquiryform-'.esc_html($form_id).'").submit();
		}
	</script>';
	$html = $javascript;
	$html .= '<form id="inquiryform-'.$form_id.'" method="POST" action=""><table id="iqfm-confirm-'.$form_id.'" class="iqfm-table">';
	$count = 1;
	foreach($result as $element){
		switch($element['field_type']) {
			case 'selectbox':
				$option = explode("\n", $element['field_option']);
				$html .= '<tr><td id="iqfm-confirm-sub-'.$count.'" class="iqfm-confirm-sub" >'.esc_html($element['field_subject']).'</td><td id="iqfm-confirm-body-'.$count.'" class="iqfm-confirm-body" >'.esc_html($option[$_POST[$element['field_name']]]).'<input type="hidden" name="'.esc_html($element['field_name']).'" value="'.esc_html($_POST[$element['field_name']]).'" /></td></tr>';
				break;
			case 'radio':
				$option = explode("\n", $element['field_option']);
				$html .= '<tr><td id="iqfm-confirm-sub-'.$count.'" class="iqfm-confirm-sub" >'.esc_html($element['field_subject']).'</td><td id="iqfm-confirm-body-'.$count.'" class="iqfm-confirm-body" >'.esc_html($option[$_POST[$element['field_name']]]).'<input type="hidden" name="'.esc_html($element['field_name']).'" value="'.esc_html($_POST[$element['field_name']]).'" /></td></tr>';
				break;
			case 'checkbox':
				$option     = explode("\n", $element['field_option']);
				$value_text = '';
				$hidden_text = '';
				if (array_key_exists($element['field_name'], $_POST)) {
					foreach($_POST[$element['field_name']] as $value){
						$value_text  .= esc_html($option[$value]).'<br />';
						$hidden_text .= '<input type="hidden" name="'.esc_html($element['field_name']).'[]" value="'.esc_html($value).'" />';
					}
				}
				$html .= '<tr><td id="iqfm-confirm-sub-'.$count.'" class="iqfm-confirm-sub" >'.esc_html($element['field_subject']).'</td><td id="iqfm-confirm-body-'.$count.'" class="iqfm-confirm-body" >'.$value_text.'</td></tr>';
				$html .= $hidden_text;
				break;
			default:
				$html .= '<tr><td id="iqfm-confirm-sub-'.$count.'" class="iqfm-confirm-sub" >'.esc_html($element['field_subject']).'</td><td id="iqfm-confirm-body-'.$count.'" class="iqfm-confirm-body" >'.esc_html($_POST[$element['field_name']]).'<input type="hidden" name="'.esc_html($element['field_name']).'" value="'.esc_html($_POST[$element['field_name']]).'" /></td></tr>';
				$html .= (($element['field_option']==='confirm')?'<input type="hidden" name="confirm-'.esc_html($element['field_name']).'" value="'.esc_html($_POST['confirm-'.$element['field_name']]).'" />':'');
				break;
		}
	$count++;
	}
	$html .= '</table>
					<input type="hidden" name="form_id" value="'.$form_id.'" />
					<input type="button" id="1nquiryformSubmit-'.$form_id.'" value="送信" onclick="inquirySubmit(\'confirm\')" />
					<input type="submit" value="戻る" cnclick="javascript:history.back();" /></form>';
	
	return $html;
}

public function show_finish() {
	return '<p>お問い合わせを承りました。ありがとうございました。</p>';
}

public function save($result, $form_id) {
	global $wpdb;
	
	$wpdb->query('UPDATE '.$wpdb->prefix.'iqfm_resultid_sequence SET id=LAST_INSERT_ID(id+1)');
	
	$resultid = $wpdb->get_results('SELECT LAST_INSERT_ID() as resultid', ARRAY_A);
	
	$wpdb->insert($wpdb->prefix.'iqfm_inquiryform_result', array(
													'form_id'   => $form_id,
													'result_id' => $resultid[0]['resultid'],
													'status'    => 0,
													'update_dt' => date('Y/m/d H:m:s'),
													'regist_dt' => date('Y/m/d H:m:s')
													), 
													array('%d','%d','%d','%s','%s'));
	
	foreach($result as $element){
		switch($element['field_type']) {
			case 'checkbox':
				$option = explode("\n", $element['field_option']);
				$field_data = '';
				if (array_key_exists($element['field_name'], $_POST)) {
					foreach($_POST[$element['field_name']] as $value){
						$field_data .= $option[$value].'<br />';
					}
				}
				break;
			case 'radio':
				$option = explode("\n", $element['field_option']);
				$field_data = $option[$_POST[$element['field_name']]];
				break;
			case 'selectbox':
				$option = explode("\n", $element['field_option']);
				$field_data = $option[$_POST[$element['field_name']]];
				break;
			default:
				$field_data = $_POST[$element['field_name']];
				$field_data = explode("\n", $field_data);
				foreach($field_data as $key => $word) {
					$n = 24;
					if (mb_strlen($word, 'UTF-8') > $n) {
						$field_data[$key] = '';
						for($i=0; $i<mb_strlen($word, 'UTF-8'); $i+=$n){
							$wk = mb_substr($word, $i, $n, 'UTF-8');
							$field_data[$key] .= "$wk\n";
						}
					}
				}
				$field_data = implode('<br />', $field_data);
				$field_data = str_replace("\n", '<br />', $field_data);
				break;
		}
		$wpdb->insert($wpdb->prefix.'iqfm_inquiryform_result_detail', array(
														'form_id'    => $form_id,
														'result_id'  => $resultid[0]['resultid'],
														'field_name' => $element['field_name'],
														'field_data' => $field_data,
														'update_dt'  => date('Y/m/d H:m:s'),
														'regist_dt'  => date('Y/m/d H:m:s')
														), 
															array('%d','%d','%s','%s','%s','%s')
					);
	}
}

private function show_err($errlist, $field_name){
	if($errlist !== false) {
		$errmsg = "";
		foreach($errlist[1][$field_name] as $msg){
			$errmsg .= '<p style="color:#FF0000;">'.$msg.'</p>';
		}
		return $errmsg;
	} else {
		return '';
	}
}

private function create_element($element, $count, $mode = '') {
	switch($element['field_type']){
		case 'text':
		case 'email':
			$attr = explode(',', $element['field_html']);
			return '<input type="text" id="iqfm-input-text-'.$count.'" name="'.(($mode === 'confirm')?'confirm-':'').$element['field_name'].'" '.$attr[0].' '.$attr[1].' value="'.($_POST[(($mode === 'confirm')?'confirm-':'').$element['field_name']]!=""?$_POST[(($mode === 'confirm')?'confirm-':'').$element['field_name']]:"").'" />';
			break;
		case 'textarea':
			$attr = explode(',', $element['field_html']);
			return '<textarea id="iqfm-input-textarea-'.$count.'" name="'.$element['field_name'].'" '.$attr[0].' '.$attr[1].' >'.($_POST[$element['field_name']]!=''?$_POST[$element['field_name']]:'').'</textarea>';
			break;
		case 'selectbox':
			$options  = explode("\n", $element['field_option']);
			$html  = '<select id="iqfm-input-selectbox-'.$count.'" name="'.$element['field_name'].'">';
			$count = 0;
			//初期値を挿入
			$html .= '<option value="default">選択してください</option>';
			foreach ($options as $option) {
				$html .= '<option value='.$count.' '.(($_POST[$element['field_name']]===(string)$count)?'selected="selected"':'').'>'.$option.'</option>';
				$count++;
			}
			$html .= '</select>';
			return $html;
			break;
		case 'checkbox':
			$attr  = explode("\n", $element['field_option']);
			$html  = '';
			$count_chk = 0;
			foreach ($attr as $value) {
				if (empty($_POST[$element['field_name']])) {
					$_POST[$element['field_name']] = array();
				}
				$html .= '<input type="checkbox" id="iqfm-input-checkbox-'.$count.'_'.$count_chk.'"  name="'.$element['field_name'].'[]" value="'.$count_chk.'" '.(in_array($count_chk, $_POST[$element['field_name']])?'checked="checked"':'').' ><label for="iqfm-input-checkbox-'.$count.'_'.$count_chk.'">'.$value.'</label><br />';
				$count_chk++;
			}
			return $html;
			break;
		case 'radio':
			$attr  = explode("\n", $element['field_option']);
			$html  = '';
			$count_rad = 0;
			foreach ($attr as $value) {
				$html .= '<input type="radio" id="iqfm-input-radio-'.$count.'_'.$count_rad.'" name="'.$element['field_name'].'" value="'.$count_rad.'" '.(($_POST[$element['field_name']]===(string)$count_rad)?'checked="checked"':'').' /><label for="iqfm-input-radio-'.$count.'_'.$count_rad.'">'.$value.'</label><br />';
				$count_rad++;
			}
			return $html;
			break;
	}
}

public function send_admin_mail($elements, $form_id) {
	global $wpdb;
	
	$result = $wpdb->get_results('SELECT count(*) as cnt FROM '.$wpdb->prefix.'iqfm_inquiryform_mail WHERE delete_flg = 0 and form_id='.$form_id, ARRAY_A);
	if ($result[0]['cnt'] == 0) {
		return;
	}
	
	$result = $wpdb->get_results('SELECT send_flg, to_address, cc_address, bcc_address, to_subject, cc_subject, bcc_subject, to_item, cc_item, bcc_item, to_body, cc_body, bcc_body FROM '.$wpdb->prefix.'iqfm_inquiryform_mail WHERE delete_flg = 0 and form_id='.$form_id, ARRAY_A);
	if ($result[0]['send_flg'] == 0) {
		return;
	} else {
		//to宛のメール送信
		$to = $result[0]['to_address'];
		$subject = $result[0]['to_subject'];
	 	$body = $this->create_body($result[0]['to_item'], $elements , 'to');
		$this->send_mail($elements, $to, $subject, $body);
		
		//cc宛のメール送信
		if ($result[0]['cc_address'] != ''){
			$to = $result[0]['cc_address'];
			$subject = ($result[0]['cc_subject']!=''?$result[0]['cc_subject']:$result[0]['to_subject']);
			$body = $this->create_body($result[0]['cc_item'], $elements , 'cc');
			$body = "このメールはあなたにccで送信されているメールです。\n\n".$body;
			$this->send_mail($elements, $to, $subject, $body);
		}
		
		//bcc宛のメール送信
		if ($result[0]['bcc_address'] != ''){
			$to = $result[0]['bcc_address'];
			$subject = ($result[0]['bcc_subject']!=''?$result[0]['bcc_subject']:$result[0]['to_subject']);
			$body = $this->create_body($result[0]['bcc_item'], $elements , 'bcc');
			$body = "このメールはあなたにbccで送信されているメールです。\n\n".$body;
			$this->send_mail($elements, $to, $subject, $body);
		}
	}

	
}

private function send_mail($elements, $to, $subject, $body) {
	foreach ($elements as $element) {
		switch ($element['field_type']) {
			case 'checkbox':
				$option = explode("\n", $element['field_option']);
				if( is_array($_POST[$element['field_name']]) ) {
					$cache = '';
					foreach($_POST[$element['field_name']] as $field_data) {
						$cache .= $option[$field_data].", ";
					}
					$body = str_replace('__'.$element['field_name'].'__', substr($cache, 0, -2), $body);
				} else {
					$body = str_replace('__'.$element['field_name'].'__', '', $body);
				}
				break;
			case 'radio':
			case 'selectbox':
				$option = explode("\n", $element['field_option']);
				$body = str_replace('__'.$element['field_name'].'__', $option[$_POST[$element['field_name']]], $body);
				break;
			default:
				$body = str_replace('__'.$element['field_name'].'__', $_POST[$element['field_name']], $body);
				break;
		}
	}
	wp_mail($to, $subject, $body);
}

private function create_body($item, $elements, $mode) {
	$item = explode(',', substr($item, 0, -1));
	if (is_array($item)) {
		$body = '';
		if (in_array($mode.'form1', $item)) {
			$body .= '■管理画面：http://'.$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME'].'?page='.WPIQF_QUERY_ADMIN."\n\n";
		}
		
		foreach ($elements as $element) {
			if (in_array($mode.'form_'.$element['field_name'], $item)) {
				$body .= '■'.$element['field_subject'].'：__'.$element['field_name']."__\n\n";
			}
		}
	}
	return $body;
}
}
add_shortcode('inquiryform', 'iqfm_inquiry_form_shortcode');
?>
